#include <Color3.hpp>
#include <stdexcept>

u8 Color3::RedChannel() const { return r; }

u8 Color3::GreenChannel() const { return g; }

u8 Color3::BlueChannel() const { return b; }

float Color3::RedChannelNormalized() const { return static_cast<float>(r) / 255.f;}

float Color3::BlueChannelNormalized() const { return static_cast<float>(b) / 255.f;}

float Color3::GreenChannelNormalized() const { return static_cast<float>(g) / 255.f;}

Color3::Color3(u8 R, u8 G, u8 B) : r(R), g(G), b(B) {}

Color3 Color3::FromHex(const std::string &hexCode) {
    // TODO: Support hex codes without the #
    // TODO: Support 9-character hex codes (with alpha), but raise a warning that suggests using Color4 instead.
    if (hexCode.length() == 7) {
        u8 r, g, b;
        std::sscanf(hexCode.c_str(), "#%02hhx%02hhx%02hhx", &r, &g, &b);
        return {r, g, b};
    }

    throw std::invalid_argument("Invalid hex code");
}

u8 *Color3::ptr() { return &r;}

const u8 *Color3::ptr() const { return &r;}
